﻿(function() {
	window.baseUrl = "https://login.kfc.com.cn/KBS/api";
	//"http://121.40.136.246:8080/KBS/api"; //
	// window.baseUrl = "https://tlogin.kfc.com.cn/KBS/api";
	// window.clientKey = "kbaptkJGtByWrQaP";
	//for uat
	window.clientKey = "kbappkwle8K1Mhlc";//for prod
	//for prod
	//for uat
	//serviceName
	window.Api = function(opt) {
		if (!opt)
			return;
		if (opt.serviceName || opt.url) {
			this.serviceName = opt.serviceName || opt.url;
		} else {
			throw ('Api error: 必须输入serviceName');
		}
	}
	window.Api.prototype = {
		exec : function(opt, cb) {
			this.getdata(opt, cb);
		},
		getdata : function(option, sc, shortTimeWaiting) {
			var ajaxOption = {};
			var url = this.serviceName;
			var optionName = []
			for (var i in option) {
				if (i.indexOf("{") != -1 && i != "{type}") {
					url = url.replace(i, option[i]);
					delete option[i];
				} else {
					if (i != "{type}")
						optionName[optionName.length] = i;

				}
			}
			optionName = optionName.sort();
			var kbcts = new Date().getTime();
			ajaxOption.url = baseUrl + url;

			if (option["{type}"] == "POST") {
				ajaxOption.type = "POST";
				delete option["{type}"];
				ajaxOption.data = JSON.stringify(option);
			} else if (option["{type}"] == "DELETE") {
				ajaxOption.type = "DELETE";
				delete option["{type}"];
				ajaxOption.data = JSON.stringify(option);
			} else {
				ajaxOption.type = "GET";
				ajaxOption.traditional = true;
				delete option["{type}"];
				ajaxOption.data = option;
			}
			var signStr = clientKey + "\t" + smartMobile.app.sec + "\t" + kbcts + "\t" + url;

			if (ajaxOption.type == "GET") {
				var queryStr = "";
				for (var i = 0; i < optionName.length; i++) {
					var value = option[optionName[i]];
					if ( typeof (value) == "undefined" || $.trim(value) == "") {
						continue;
					} else if ( value instanceof Array) {
						for (var j = 0; j < value.length; j++)
							queryStr = queryStr + optionName[i] + "=" + value[j] + "&";
					} else
						queryStr = queryStr + optionName[i] + "=" + value + "&";

				}
				signStr = signStr + "\t" + queryStr.substr(0, queryStr.length - 1);
			} else
				signStr = signStr + "\t\t" + JSON.stringify(option);
			console.log(signStr);

			ajaxOption["beforeSend"] = function(xhr) {
				xhr.setRequestHeader("kbck", clientKey);
				xhr.setRequestHeader("kbcts", kbcts);
				xhr.setRequestHeader("kbsv", $.md5(signStr));
			};

			ajaxOption["success"] = function(ret, textStatus, jqXHR) {
				var res = ret;
				if ( typeof (ret) == "string") {
					try {
						res = JSON.parse(ret);
					} catch (e) {
						//console.log(e);
					}
				}
				if (res && (res.errCode == -1 || res.errCode == 400001)) {
					//amGloble.userInfo = null;
					//localStorage.removeItem(amGloble.page.login.loginStatusKey);
					if (amGloble.userInfo && amGloble.userInfo.token) {
						amGloble.userInfo.token = null;
						amGloble.userInfo.pwd = null;
					} else {
						amGloble.userInfo = null;
					}
					sc({
						errCode : -10,
						errMsg : "登录已过期,请重新登录!"
					});
				} else {
					var resource = jqXHR.getResponseHeader('resouceVersion');
					if (resource) {
						res['resouceVersion'] = resource;
						res['iphoneVersion'] = jqXHR.getResponseHeader('iphoneVersion');
						res['androidVersion'] = jqXHR.getResponseHeader('androidVersion');
						//console.log('res'+JSON.stringify(res));
					}
					sc(res);
				}
			};
			ajaxOption["error"] = function(ret) {
				sc({
					errCode : -1,
					errMsg : "无可用网络连接，离线状态下无法使用此功能"
				});
			};
			ajaxOption.timeout = 1000 * 10;
			ajaxOption.contentType = 'application/json; charset=UTF-8';
			//console.log(ajaxOption);
			$.ajax(ajaxOption);
		}
	}

	/*
	 * ApiCacheable类,实例化一个service对象,通过调用这个对象的exec方法执行一个service
	 * @Class
	 * @public
	 *
	 * @param opt.serviceName   [string]    必需      undefined   service名称
	 * @param opt.keys          [array]     必需      undefined   参数名
	 * @param opt.memoryCache   [boolean]   可选      false       是否启用内存缓存
	 * @param opt.isSuccess     [function]  必需      返回是否成功调用业务数据,参数为结果
	 *
	 * @return                  [ApiCacheable]
	 */
	ApiCacheable = function(opt) {
		if (!opt)
			return;
		Api.call(this, opt);
		if (opt.keys && opt.isSuccess) {
			this.keys = opt.keys;
			this.isSuccess = opt.isSuccess;
			this.ignoreTS = opt.ignoreTS;
		} else {
			throw ('ApiCacheable error: 参数有误,必须输入keys[array],isSuccess[function]');
		}
		this.memoryCache = opt.memoryCache;
		this.storeData = {};
	}
	ApiCacheable.prototype = new Api();
	/*
	 * 获取作为cache使用的key,此key由servicename和参数组成(过滤掉keyFilter);
	 * @function
	 * @private
	 * @param    opt    [object]     必需      调用service的时的option
	 *
	 * @return   key    [string]
	 */
	ApiCacheable.prototype._key = function(opt) {
		var key = "BRANDKFC_" + this.serviceName;
		if (this.keys) {
			for (var i = 0; i < this.keys.length; i++) {
				if ( typeof (opt[this.keys[i]]) == "undefined")
					continue;
				if ( typeof (opt[this.keys[i]]) == "object") {
					key = key + "_" + JSON.stringify(opt[this.keys[i]]);
				} else {
					key = key + "_" + opt[this.keys[i]];
				}
			}
		}
		return key;
	},
	/*
	 * 读取本地存储中的数据
	 * @function
	 * @private
	 * @param    opt    [string]     必需      接口参数
	 *
	 * @return   result [object]     service的本地数据
	 */
	ApiCacheable.prototype._get = function(opt) {
		var key = typeof (opt) == "string" ? opt : this._key(opt);
		var temp = localStorage.getItem(key);
		if (!temp) {
			return;
		}
		try {
			temp = JSON.parse(temp);
		} catch (e) {
			$.am.debug.log("api.get JSON.parse error:" + key);
			temp = null;
		}
		return temp;
	},
	/*
	 * 保存service数据到本地存储中
	 * @function
	 * @private
	 * @param    opt    [object]     必需      接口参数
	 * @param    data   [object]     必需      调用数据成功后得到的数据
	 *
	 * @return   result [object]     service的本地数据
	 */
	ApiCacheable.prototype._save = function(opt, data) {
		localStorage.setItem( typeof (opt) == "string" ? opt : this._key(opt), JSON.stringify(data));
	},
	/*
	 * 添加一个数据对象到缓存中
	 * @function
	 * @public
	 * @param    option  [object]     必需     缓存数据的参数,需要以此参数生成key
	 * @param    item    [function]   必需     要插入的数据对象
	 * @param    noCache [boolean]    可选     目标路径,如:"responseData.data.storelist"
	 *
	 * @return
	 * @description
	 */
	ApiCacheable.prototype.addItemToCache = function(option, item, targetPath) {

	},
	/*
	 * 执行service
	 * @function
	 * @public
	 * @param    option  [object]     必需     调用service的时的option
	 * @param    sc      [function]   必需     回调函数
	 * @param    noCache [boolean]    可选     是否忽略缓存数据
	 *
	 * @return
	 */
	ApiCacheable.prototype.exec = function(opt, cb, noCache) {
		var key = this._key(opt),
		    _this = this;

		if (!noCache && this.memoryCache && this.storeData[key]) {
			//如果内存中有数据
			cb(_this.storeData[key], 2);
			return;
		}
		if (!this.ignoreTS) {
			opt.ts = (opt.ts || localStorage.getItem(key + "ts") || 946656000000);
		}
		_this.getdata(opt, function(ret) {
			if (_this.isSuccess(ret)) {
				//调用成功
				if (!_this.ignoreTS && ret.data.ts == opt.ts) {
					//调用成功,但无更新,返回local数据
					cb(_this._get(key), 1);
				} else {
					//调用成功,有更新
					//保存新数据
					_this._save(key, ret);
					//更新ts
					!_this.ignoreTS && localStorage.setItem(key + "ts", ret.data.ts);
					//写入内存
					_this.memoryCache && (_this.storeData[key] = ret);
					//
					cb(ret);
				}
			} else {//两种情况：1、离线；2、4XX或者5XXX错误
				//返回失败信息
        console.log('error');
        console.log(ret);
        if (ret.errCode == -1) {  //离线，则使用cache，无cache则向上抛
          var localdata = _this._get(key);
          if (localdata) {
            $.am.debug.log("API_local:" + key);
            cb(localdata);
          } else {
            cb(ret);
          }
        } else {  //服务端错误，则统一处理，不再向上抛
          if (ret.errCode != 0) {
            amGloble.showErrMsg(ret.errCode, {
              msg: ret.errMsg,
              errData: ret.errData
            });
          } else {  //isSuccess判断不准确时，处理
            cb(ret);
          }
        }
			}
		});
	}
})();

/*
 $(function () {
 var baseUrlCount = 0;
 window.baseUrl = localStorage.getItem("BRANDKFC_baseUrl");
 if (!window.baseUrl) {
 //window.baseUrl = "http://121.40.136.246:8080/KBS/api";
 window.baseUrl = "http://t.a.kfc.com.cn/KBS/api";
 }
 //window.baseUrl = "http://error_test";
 $("#switchBaseUrl").vclick(function () {
 baseUrlCount++;
 if (baseUrlCount%5==0) {
 if (window.baseUrl == "http://121.40.136.246:8080/KBS/api") {
 window.baseUrl = "http://t.a.kfc.com.cn/KBS/api";
 } else {
 window.baseUrl = "http://121.40.136.246:8080/KBS/api"
 }
 amGloble.msg("BASEURL已改变:" + window.baseUrl);
 localStorage.setItem("BRANDKFC_baseUrl", window.baseUrl);
 }
 });

 var clearCache = 0;
 $("#clearCache").vclick(function () {
 baseUrlCount++;
 if (baseUrlCount % 5 == 0) {
 navigator.notification.confirm("此操作会清除所有缓存,确定清除吗?", function (button) {
 if (button == 1) {
 localStorage.clear();
 //清除以后 要保持内存中 个人中心中信息
 amGloble.util.storage.set("BRANDKFC_/login", amGloble.userInfo);
 }
 }, "清除缓存", ["确定", "取消"]);
 }
 });

 })*/
