﻿(function() {
	var _name = "BRANDKFC_img_";
	var _threadId = 0;

	var _downloadedList = {};
	var _downloadingList = {};

	var _runCallbacks = function(id, ret) {
		var cbs = _downloadingList[id].callbacks;
		for (var i = 0; i < cbs.length; i++) {
			cbs[i](ret);
		};
	};
	var _saveData = function(id, value) {
		window.localStorage.setItem(_name + id, value);
	};
	var _getData = function(id) {
		return window.localStorage.getItem(_name + id);
	};
	var _removeData = function(id) {
		// $.am.debug.log("remove" + id);
		delete _downloadedList[id];
		window.localStorage.removeItem(_name + id);
	};
	var getPicture = function (id, cb) {
	    try{
	        id = id.replace(/\\/g, "/");
	        if(id.indexOf($.am.imgSvr)!=-1)
	        {
	        	id=id.replace($.am.imgSvr,"");
	        }
	    } catch (e) {

	    }
		if (id == null) {
			cb && cb({
				error : 1,
        id: id,
				data : "Download failed!"
			});
			return;
		}
		//在cache中检索到
		var filename = _downloadedList[id];
	    // $.am.debug.log("cache:" + filename + ":" + id);

		if (filename) {
			//callback
			cb && cb({
				type : 2, //local
				error : 0,
        id: id,
				data: smartMobile.app.sourceRoot + filename
			});
			return;
		}

		//在storage中检索到
		filename = _getData(id);
		if (filename) {
			//save in cache
		    _downloadedList[id] = filename;
            
			//callback
			cb && cb({
				type : 1, //local
				error : 0,
        id: id,
				data: smartMobile.app.sourceRoot + filename
			});
			$.am.debug.log("local:" + smartMobile.app.sourceRoot + filename);
			return;
		}

		var item = _downloadingList[id];
		if (item) {
			//add callback to callbacks array
			item.callbacks.push(cb);
			return;
		}

		//add download
		//add info to downloading list, status is 1
		var down = _downloadingList[id] = {
			threadId : _threadId++,
			filename : "",
			callbacks : [cb]
		};
		//$.am.debug.log($.am.imgSvr + id);
		var url;
		if(id.indexOf("http")!=-1)
			url=id;
		else
			url=$.am.imgSvr + id;
		smartmobile.fileTransfer.download({
		    threadId: 1,
		    url: url
		}, function (ret) {
		    //成功时
		    if (typeof ret == "string") {
		        ret = JSON.parse(ret);
		    }

		    //$.am.debug.log(JSON.stringify(ret));

		    var filename = "SUPER_APP_FILE:///" + ret.content.sourceRoot + ret.content.relativePath;
		    amGloble.sourceRoot = ret.content.sourceRoot;
		    //$.am.debug.log(filename);

		    //转移到cache和storage
		    _downloadedList[id] = ret.content.relativePath;
		    _saveData(id, ret.content.relativePath);
		    //callbacks
		    _runCallbacks(id, {
		        error: 0,
            id: id,
		        data: filename
		    });
		    //删除downloading列表中
		    delete _downloadingList[id];
		}, function (ret) {
		    //失败时
		    //callbacks
		    _runCallbacks(id, {
		        error: 1,
            id: id,
		        data: "Download failed!"
		    });
		    //删除downloading列表中
		    delete _downloadingList[id];
		});
	};

	$.am.preloadImgs = function(id) {
		getPicture(id);
	};
	$.fn.getPicture1 = function(id, scb, fcb) {
		var self = this;
		var getOnce = function() {
			getPicture(id, function(ret) {
				if (!ret.error) {
					self.unbind().bind({
						"load" : function() {
						    //$.am.debug.log("img loaded" + ret.data);
							self.show();
							scb && scb.call(self, ret);
						},
						"error" : function() {
						    //$.am.debug.log("img load failed! clear"+ret.data);
							_removeData(id);
							if (ret.type) {
								getOnce();
							}
						}
					});
					self.attr("src", ret.data);
				} else {
					//$.am.debug.log("img download error "+id);
					fcb && fcb.call(self);
				}
			});
		};
		getOnce();
		return this;
	};
	$.fn.getPicture = function(id, scb, fcb) {
		id = id.replace(/\\/g, "/");
		if(id.indexOf('http') == -1)
		{
			id = $.am.imgSvr + id;
		}
		$.am.debug.log("src="+id);
		this.attr("src", id);
	};
	$.am.imgSvr = ""
})();
