﻿if (!window.amGloble.util) window.amGloble.util = {};

(function () {
    var Photo = function (e) {
        this.id = e.id;
        $.extend(this, e);
        $.am.components.push(this);
        $.am.Component.call(this, e);
    }
    Photo.prototype = {
        componentInit: function () {
            var _this = this;
            this.$ = $("#" + this.id);
            this.$t = this.$.find("a.title");

            this.$.find("a.cancel").vclick(function () {
                _this.hide();
            });

            this.$.find("a.takePicture").vclick(function () {
                amGloble.getPicture({
                    width: 300,
                    height: 300,
                    type: 0
                }, function (ret) {
                    _this.hide();
                    _this.cb(ret);
                }, function (ret) {
                    $.am.debug.log("FAILED:" + JSON.stringify(ret));
                    _this.hide();
                    _this.cb(ret);
                    if (ret != 'no image selected') amGloble.msg("图片获取失败!");

                });
            });

            this.$.find("a.selectPicture").vclick(function () {
                amGloble.getPicture({
                    width: 300,
                    height: 300,
                    type: 1
                }, function (ret) {
                    _this.hide();
                    _this.cb(ret);
                }, function (ret) {
                    $.am.debug.log("FAILED:" + JSON.stringify(ret));
                    _this.hide();
                    _this.cb(ret);
                    if (ret != 'no image selected') amGloble.msg("图片获取失败!");
                });
            });
        },
        show: function (opt) {
            var _this = this;
            this.cb = opt.callback;
            this.$t.text(opt.title);
            this.$.show();
        },
        hide: function () {
            this.$.hide();
        }
    }
    //localStorage工具
    amGloble.util.photo = new Photo({
        id: "share_cover_photo"
    });
    amGloble.util.countNum = {
        times: 60,
        codeInter: null,
        timeBtn: null,
        start: function (timeBtn, time) {
            this.times = parseInt(time) || 60;
            this.timeBtn = $(timeBtn);
            var that = this;
            /*inputDom.on('input propertychange', function () {
             var val = $(this).val();
             if (val.length == 4)  clearTime();
             });*/
            this.timeBtn.addClass('button-disable').removeClass("button-red");
            if (this.codeInter == null) {
                this.codeInter = setInterval(function () {
                    that.times--;
                    if (that.times > -1) {
                        that.timeBtn.text(that.times + "秒");
                    } else {
                        that.clearTime();
                    }
                }, 1000);
            }
        },
        clearTime: function () {
            if (this.timeBtn) {
                this.timeBtn.removeClass('button-disable').addClass("button-red");
                this.timeBtn.text("发送验证码");
            }
            clearInterval(this.codeInter);
            this.codeInter = null;
        }

    };
    var Hyperlink = function (e) {

    }
    Hyperlink.prototype = {
        componentInit: function () {

        },
        // 宅急送 wap 链接跳转 hard code
        hardCodeLinkZJS: function (url) {
            var url = url || "https://m.4008823823.com.cn/kfcmwos/brandAppLogin.do?utm_campaign=Ownmedia&utm_source=KFCBrandAPP&token=${token}";
            if (url && url.indexOf('m.4008823823.com.cn') > -1) {
                //url = "http://m.4008823823.com.cn/?utm_campaign=Ownmedia&utm_source=KFCBrandAPP";
                if (amGloble.userInfo && amGloble.userInfo.token) {
                    url = url.replace('${token}', amGloble.userInfo.token);
                } else {
                    url = url.replace('${token}', 'null');
                }
            }
            window.open(url, '_blank');
        },
        show: function (data) {
            var action = data.action, _this = this;
            if (!action) {
                //window.open("http://u.m.4008823823.com.cn/kfcmwos/home.do");
                var url = "http://m.4008823823.com.cn/?utm_campaign=Ownmedia&utm_source=KFCBrandAPP";
                _this.hardCodeLinkZJS(url);
                return;
            }
            //console.log("Hyperlink", action); =
            /*action = {
             type: 6,
             params: {
             funId: "xmasLuckyDraw2014"
             }
             };*/
            switch (action.type) {
                case 0:
                    // 外链：{type:'0', params:{url:''}}，注storeCode与电话参数为 ${storeCode}与${userPhone}，注：跳出APP显示
                    var url = action.params.url;
                    _this.hardCodeLinkZJS(url);
                    break;
                case 1:
                    //大图：{type:'1',params:{pic:'',praise:false, share:false, action:{type:'',params:{name1:'value1'}}}}，注：pic为大图的URL，超链为嵌套结构
                    //alert("查看大图");
                    action.params.name = data.name;
                    amGloble.page.photoViewer.changeToMe("slideleft", action.params);
                    break;
                case 2:
                    // APP内部：{type:'2',parmas:{module:'P|C|S|F|D|M',itemId:''}}，注：P活动，C优惠券，F美食，S餐厅，D发现，M个人中心
                    //if (action.params.module == "P") {
                    //    amGloble.page.localActivity.changeToMe("slideleft");
                    //}else if(action.params.module == "C") {
                    //    amGloble.page.coupons.changeToMe("slideleft");
                    //} else if (action.params.module == "S") {
                    //    amGloble.page.storeList.changeToMe("slideleft");
                    //} else if (action.params.module == "F") {
                    //    amGloble.page.foodCourt.changeToMe("slideleft");
                    //} else if (action.params.module == "D") {
                    //    amGloble.page.found.changeToMe("slideleft");
                    //} else if (action.params.module == "M") {
                    //    if (amGloble.userInfo && amGloble.userInfo.token) {
                    //        amGloble.page.ourCenterHaveGift.changeToMe("slideleft");
                    //    } else {
                    //        amGloble.page.login.changeToMe("slideleft");
                    //    }
                    //} else if (action.params.module == "SIGN") {
                    //    if (amGloble.userInfo && amGloble.userInfo.token) {
                    //        if (amGloble.userInfo && amGloble.userInfo.type == 0){
                    //            amGloble.page.signInCreat.changeToMe("slideleft", action.params.itemId);
                    //        } else {
                    //            amGloble.util.validPhone.show( {phone:amGloble.userInfo.phone || ''} );
                    //        }
                    //    } else {
                    //        amGloble.page.login.changeToMe("slideleft",window.amGloble.page.storeDetail);
                    //    }
                    //}
                    break;
                case 3:
                    //内部HTML页面：{type:'3',params:{url:''}}，注：显示在APP内部
                    //window.open(action.params.url);
                    _this.hardCodeLinkZJS(action.params.url);
                    break;
                case 4:
                    //图文内容：{type:'4',params:{pic:[''],html:''}}，注：显示在APP内部，html属性值为html的内容
                    action.params.name = data.name;
                    amGloble.page.activityDetail.changeToMe("slideleft", action.params);
                    break;
                case 5:
                    //其他APP：{type:'5',params:{android:{action:'',uri:'',type:'',category:'',pkg:'',class:''},ios:{url:''},url:''}}
                    //$.am.debug.log("action:" + JSON.stringify(action));
                    //try {
                    //    var opt,
                    //        adId = smartMobile.app.deviceId || '',
                    //        token = amGloble.userInfo && amGloble.userInfo.token || '';
                    //    if (smartMobile.app.deviceType == "ios") {
                    //        var url = action.params.ios.url;
                    //        if (url.indexOf('${token}') > -1){
                    //            url = url.replace('${token}', token);
                    //        }
                    //        if (url.indexOf('jsonParams={') > -1) {
                    //            var s = 'jsonParams={"adid":"'+adId+'",';
                    //            url = url.replace('jsonParams={', s);
                    //        }
                    //        action.params.ios.url = url;
                    //        opt={
                    //            url: url,
                    //            jsonParams: action.params.ios
                    //        };
                    //    } else {
                    //        //amGloble.msg("唤起其它APP");
                    //        var severToken = action.params.android.token || '',
                    //            jsonParams = {classURL: action.params.android.classURL};
                    //        if (severToken && severToken == '${token}') {
                    //            jsonParams.token = token;
                    //        }
                    //        //jsonParams.adid = adId;
                    //        opt = {url: action.params.android.url};
                    //        opt.jsonParams = jsonParams;
                    //    }
                    //    $.am.debug.log("yum.sys.openApp:" + JSON.stringify(opt));
                    //    smartMobile.sys.isOpenAppEnable(opt,
                    //        function(ret){
                    //            $.am.debug.log(JSON.stringify(ret));
                    //            if (ret.content) {
                    //                //跳转用户安装APP
                    //                smartMobile.sys.openApp(opt,
                    //                    function(ret) { }, function (ret){ });
                    //            }else {
                    //                //跳转APP store
                    //                var url = action.params.url;
                    //                var types = null;
                    //                if (url && url.indexOf('#AppStore=') > -1) {
                    //                    var splitArr = url.split('#AppStore=');
                    //                    url = splitArr[0];
                    //                    types = splitArr[1];
                    //                }else {
                    //                    types = null;
                    //                }
                    //                if (smartMobile.app.deviceType == "ios") {
                    //                    if (types == 'Delivery') {//#AppStore=Delivery
                    //                        url = 'itms-apps://itunes.apple.com/cn/app/id655012687?mt=8';
                    //                    } else if (types == 'PreOrder') {//#AppStore=PreOrder
                    //                        url = 'https://itunes.apple.com/cn/app/kfc-zi-zhu-dian-can/id807450525?mt=8';
                    //                    }
                    //                } else if(smartMobile.app.deviceType == "android") {
                    //                    //url = action.params.url;
                    //                }
                    //                $.am.debug.log("url:"+url);
                    //                if (types && types != null) {
                    //                    smartMobile.sys.openApp({ url:url, jsonParams:''},
                    //                        function(ret) {},
                    //                        function (ret) {
                    //                            //window.open(url);
                    //                            _this.hardCodeLinkZJS( url );
                    //                        });
                    //                } else {
                    //                    //window.open(url);
                    //                    _this.hardCodeLinkZJS( url );
                    //                }
                    //            }
                    //        },function(ret){
                    //            //window.open(action.params.url);
                    //            _this.hardCodeLinkZJS( action.params.url );
                    //        });
                    //} catch (e) {
                    //    $.am.debug.log(e);
                    //}
                    break;
                case 6:
                    //游戏
                    //$.am.debug.log("超链类型6, 调起游戏:" + action.params.funId);
                    //if (action.params && action.params.funId == "xmasLuckyDraw2014") {
                    //    _this.launchGame();
                    //} else if (action.params && action.params.funId == "MEMBER_RECRUIT") {  //会员招募
                    //    if (amGloble.userInfo && amGloble.userInfo.token) { //登录后
                    //        if (typeof amGloble.userInfo.isMember !== 'undefined' && amGloble.userInfo.isMember) {//会员直接进入个人中心
                    //            amGloble.page.ourCenterHaveGift.changeToMe("slideleft");
                    //        } else {
                    //            amGloble.page.memberRecruit.changeToMe("slideleft");
                    //        }
                    //    } else {  //匿名用户
                    //        amGloble.page.login.changeToMe("slideleft");
                    //    }
                    //} else if (action.params && action.params.funId == "TAG_QUESTIONNAIRE") { //打Tag问卷
                    //    if (amGloble.userInfo && amGloble.userInfo.token) {
                    //        var url = action.params.svcRoot.replace("${token}",amGloble.userInfo.token);
                    //        var birthday = "";
                    //        if (amGloble.userInfo.birthday && amGloble.userInfo.birthday.length>0){
                    //            birthday = amGloble.userInfo.birthday;
                    //        } else if (amGloble.userInfo.byear && amGloble.userInfo.byear.length>0){
                    //            birthday = amGloble.userInfo.byear;
                    //        }
                    //        url = url.replace("${birthday}", birthday);
                    //        window.open(url, '_blank');
                    //    } else {
                    //        amGloble.page.login.changeToMe("slideleft");
                    //        return false;
                    //    }
                    //}
                    break;
            }
            //to do
        },
        hide: function () {

        },
        //launchGame: function (extInfo, gameInfo) {
        //    var _this = this;
        //    try {
        //        var opt = {
        //            option: {
        //            }
        //        }
        //        if (amGloble.userInfo) {
        //            if (amGloble.userInfo.type!=0) {
        //                navigator.notification.confirm("你还不是肯德基的正式用户,请先以正式用户身份登录！", function (button) {
        //                    if (button == 1) {
        //                        amGloble.page.login.changeToMe("slideup", "lunchGame");
        //                    } else if (button == 2) {
        //
        //                    }
        //                }, "需要正式用户身份", ["登录", "返回"]);
        //                return;
        //            }
        //            opt.option.userInfo = {
        //                id: amGloble.userInfo.id,
        //                token: amGloble.userInfo.token,
        //                nickname: amGloble.userInfo.nickname
        //            }
        //        }
        //        if (extInfo) {
        //            opt.option.shared = extInfo;
        //        }
        //        if (gameInfo) {
        //            opt.option.gameInfo = gameInfo;
        //        }
        //        $.am.debug.log("INPUT:" + JSON.stringify(opt));
        //
        //        //alert("launchGame20141224");
        //        setTimeout(function () {
        //            yum.games.launchGame20141224(opt, function (ret) {
        //                $.am.debug.log("OUTPUT:"+JSON.stringify(ret));
        //                if (ret && ret.result == 0 && ret.content) {
        //                    if (ret.content.action == "login") {
        //                        //表示需要登录
        //                        //登录完成后重新lunchGame,并输入userInfo
        //                        //
        //                        amGloble.page.login.changeToMe("slideup", "lunchGame");
        //                    } else if (ret.content.action == "share") {
        //                        //进入分享步骤
        //                        /*
        //                         {
        //                         action:"share",
        //
        //                         extInfo:{                               //返回的数据也封装到一个extInfo里面，以便以后的活动通用
        //                         gameInfo:"",
        //                         text:"分享的文案",
        //                         image:"分享的图片的本地路径",
        //                         url:"分享的超链"
        //                         }
        //                         }*/
        //
        //                        /*
        //                         *他大爷
        //                         层层嵌套不复杂不舒服司机傻B型接口参数格式
        //                         不出文档，别人出了文档不按文档做，写个simple能拖几天
        //                         {
        //                         userInfo : {},
        //                         extInfo : {},
        //                         gameInfo : {
        //                         action : "login"
        //                         extInfo : {
        //                         action : "share"
        //                         extInfo : {
        //                         gameInfo : {
        //                         gameType = "flowGame"//游戏类型:flowGame  shakeGame
        //                         result = "1"
        //                         winGoods = "0"//赢的奖品: 0：没中奖   1：全家桶   2：话费   3:pad  4: 微单     5:单反    6：次数已经用完
        //                         useTime = "6"//游戏次数
        //                         }
        //                         text =  ""
        //                         image =  ""
        //                         url =  ""
        //                         }
        //                         }
        //                         }
        //                         }
        //                         */
        //                        _this.shareGame({
        //                            content: ret.content.extInfo.text,
        //                            imagePath: ret.content.extInfo.image,
        //                            link: ret.content.extInfo.url,
        //                            launchGame: 1
        //                        }, ret.content.extInfo.gameInfo);
        //                    } else if (ret.content.action == "pocket") {
        //                        //流程结束
        //                        /*
        //                         {action:"pocket"}
        //                         */
        //                        window.amGloble.page.pocket.changeToMe("slideleft");
        //                    } else if (ret.content.action == "completed") {
        //                        //结束流程
        //                        //{action:"completed"}
        //                        //do nothing
        //                    }
        //                }
        //            }, function (ret) {
        //                $.am.debug.log("failed:" + JSON.stringify(ret));
        //                if (ret && ret.result == 0 && ret.content) {
        //
        //                }
        //            });
        //        }, 100);
        //    } catch (e) {
        //        $.am.debug.log(e);
        //    }
        //
        //},
        //shareGame: function (opt, gameInfo) {
        //    var _this = this;
        //    amGloble.util.share.show(opt, function (shareRet) {
        //        $.am.debug.log("share:" + JSON.stringify(shareRet));
        //        //return;
        //        setTimeout(function () {
        //            if (shareRet && shareRet.errCode == 0) {
        //                //amGloble.msg("分享成功!");
        //                //navigator.notification.alert("分享成功,可以参加抽奖啦!", function () {
        //                _this.launchGame("true", gameInfo);
        //                //}, "分享成功", "去抽奖");
        //            } else if (shareRet && shareRet.errCode == 0) {
        //
        //                navigator.notification.confirm("分享游戏即可参加抽奖，确定要放弃机会吗?", function (button) {
        //                    if (button == 1) {
        //                        _this.shareGame(opt, gameInfo);
        //                    } else if (button == 2) {
        //                        _this.launchGame();
        //                    }
        //                }, "放弃抽奖", ["分享", "放弃"]);
        //            } else {
        //                navigator.notification.confirm("分享失败，分享游戏即可参加抽奖，确定要放弃机会吗?", function (button) {
        //                    if (button == 1) {
        //                        _this.shareGame(opt, gameInfo);
        //                    } else if (button == 2) {
        //                        _this.launchGame();
        //                    }
        //                }, "分享失败!", ["重试", "放弃"]);
        //            }
        //        }, 100);
        //    });
        //},
        //isGameUsable: function () {
        //    if (yum.games && typeof (yum.games.launchGame20141224) == "function") {
        //        return 1;
        //    }
        //}
    }
    amGloble.util.hyperlink = new Hyperlink();


    //localStorage工具
    amGloble.util.storage= {
        get: function (key) {
            var json = localStorage.getItem(key);
            try{
                json = JSON.parse(json);
            } catch (e) {

            }
            return json;
        },
        set: function (key,data) {
            var val;
            if (typeof (data) == "object") {
                val = JSON.stringify(data);
            } else {
                val = data;
            }

            localStorage.setItem(key, val);
        }
    }
    var Share = function (e) {
        this.id = e.id;
        $.extend(this, e);
        $.am.components.push(this);
        $.am.Component.call(this, e);
    }
    Share.prototype = {
        componentInit: function () {
            var _this = this;
            this.$ = $("#" + this.id);
            this.$c = this.$.find("div.container");
            this.$.find("div.page-button").vclick(function () {
                _this.hide();
                _this.cb && _this.cb({errCode: -10});//用户放弃
            });
            var inName = this.inName = {
                "sina": "sina", "wechat.session": "wechat.session",
                "wechat.moment": "wechat.moment", "qq": "qq",
                "qzone": "qzone", "qweibo": "qweibo", "douban": "douban", "renren": "renren"
            };
            this.$.find("li").vclick(function () {
                _this.hide();
                var name = $.trim($(this).attr("sharename"));
                name = inName[name];
                if (name && typeof name != 'undefined') {
                    _this._share(name);
                } else {
                    amGloble.msg("暂不支持");
                }
            });
            localStorage.removeItem("KFC_availableSite");
        },
        /*
         amGloble.util.share.show({
         content:"分享内容,需要根据分享模板生成",
         imagePath:"图片路径",
         award:1   //1抽奖,0不抽奖
         signStore:"A" //签到分享的门店
         },function(ret){
         if(ret && ret.errCode == 0){
         amGloble.msg("分享成功!");
         }else{
         amGloble.msg("分享成功!");
         }
         })
         */
        show: function (opt, cb) {
            if (amGloble.userInfo && amGloble.userInfo.token) {
                if (amGloble.userInfo && amGloble.userInfo.type != 0) {
                    this.$.hide();
                    amGloble.util.validPhone.show({phone: amGloble.userInfo.phone || ''});
                    return false;
                }
            } else {
                this.$.hide();
                amGloble.page.login.changeToMe("slideup");
                return false;
            }

            if (!opt || !opt.content || !opt.imagePath) {
                // amGloble.msg("DEV tips: 请输入{content:'分享内容',imagePath:'分享图片'}");
            }
            this.availableSite();
            this.opt = opt;
            this.cb = cb;
            var _this = this;
            this.$c.setTransformPos(325, "y");
            this.$.show();
            _this.$c.animateTranslate3d(325, 0, "y", 200);

        },
        hide: function () {
            var _this = this;
            _this.$c.animateTranslate3d(0, 325, "y", 200, function () {
                _this.$.hide();
            });
        },
        availableSite: function () {
            var _this = this;
            var inName = this.inName;
            var _availableSite = function (d, inName) {
                for (var p in inName) {
                    if (p == 'wechat.session' || p == 'wechat.moment') {
                        p = 'wechat';
                    }
                    var siteDom = _this.$.find('[data-role=' + p + ']');
                    //$.am.debug.log('Site:'+p + '::'+ d.indexOf(p));
                    if (d.indexOf(p) > -1) {
                        siteDom && siteDom.show();
                    } else {
                        siteDom && siteDom.hide();
                    }
                }

            };
            var avaiSite = amGloble.util.storage.get('KFC_availableSite') || null;
            if (avaiSite && JSON.stringify(avaiSite).length > 0) {
                _availableSite(avaiSite, inName);
                return false;
            }
            smartMobile.social.availableSite(function (r) {
                //$.am.debug.log('ShareSite:'+ JSON.stringify(r) );
                if (r && r.result == 0 && r.content) {
                    var d = r.content;
                    amGloble.util.storage.set('KFC_availableSite', d);
                    _availableSite(d, inName);
                }
            }, function (r) {
                //$.am.debug.log('ShareSiteff:'+ JSON.stringify(r) );
            });

        },
        _share: function (site) {
            //smartmobile.social.availableLoginSite(function(r){ $.am.debug.log('LoginSite:'+ JSON.stringify(r) ); },function(r){ alert(JSON.stringify(r)) });
            //smartmobile.social.availableBindSite(function(r){ $.am.debug.log('BindSite:'+ JSON.stringify(r) ); },function(r){ alert(JSON.stringify(r)) });
            //smartmobile.social.availableShareSite(function(r){ $.am.debug.log('ShareSite:'+ JSON.stringify(r) ); },function(r){ alert(JSON.stringify(r)) });
            $.am.debug.log(site);
            var _this = this,
                failCll = function (code) {
                    code = code || 1;
                    amGloble.loading.hide();
                    _this.cb && _this.cb({errCode: code});
                };
            try {
                var bindSite = site;
                var authKey = amGloble.snsAuth[site];
                var auth = amGloble.userInfo[authKey] || null;
                var snsKey = "snsBind_" + amGloble.userInfo.id;
                var sndBind = amGloble.util.storage.get(snsKey) || {};
                if (bindSite == "wechat.session" || bindSite == "wechat.moment") {
                    bindSite = "wechat";
                }
                smartmobile.social.isBound({site: bindSite, auth: auth}, function (ret) {
                    $.am.debug.log(JSON.stringify(ret));
                    if (ret.result == 0) {
                        //  {
                        //  result:0,
                        //  message:””,
                        //  content:true/false
                        //}
                        var content;
                        if (_this.opt.signStore) {
                            if (_this.opt.award) {
                                content = amGloble.metaData.awardSignTmplPrefix + _this.opt.content + amGloble.metaData.awardSignTmplSuffix;
                            } else {
                                content = amGloble.metaData.nonAwardSignTmplPrefix + _this.opt.content + amGloble.metaData.nonAwardSignTmplSuffix;
                            }
                            content = content.replace("${storeName}", _this.opt.signStore);
                        } else {
                            if (_this.opt.award) {
                                content = amGloble.metaData.awardShareTmplPrefix + _this.opt.content + amGloble.metaData.awardShareTmplSuffix;
                            } else {
                                content = amGloble.metaData.nonAwardShareTmplPrefix + _this.opt.content + amGloble.metaData.nonAwardShareTmplSuffix;
                            }
                        }
                        if (ret.content) {
                            /*$.am.debug.log("已绑定");
                             $.am.debug.log("smartmobile.social.shareTo: " + JSON.stringify({
                             "site": site,
                             "auth":auth,
                             "content": content,
                             "title": _this.opt.title || "肯德基",
                             "link": _this.opt.link || "http://m.kfc.com.cn/APP/",//
                             "imagePath": (site!='douban'&&_this.opt.imagePath) || null
                             }));*/
                            if (!_this.opt.signStore || typeof(_this.opt.signStore) == 'undefined') {
                                amGloble.loading.show("正在分享...");
                            }
                            //如果是如下 site 到第三方软件停留后 就没有回调了
                            if (site == 'qq' || site == 'qzone' || site == 'wechat.session' || site == 'wechat.moment') {
                                amGloble.loading.hide();
                            }
                            if (site == 'wechat.session' || site == 'wechat.moment') {
                                content = content.replace("更多优惠和活动，欢迎下载肯德基APP：http://m.kfc.com.cn/APP", "");
                            }
                            var dty = smartMobile.app.deviceType,
                                androidDownUrl = 'http://sj.qq.com/myapp/detail.htm?apkName=com.yek.android.kfc.activitys';
                            content = content + "\n" + "app下载：" + androidDownUrl;
                            smartmobile.social.shareTo({
                                "site": site,
                                "auth": auth,
                                "content": content || "",
                                "title": _this.opt.title || "肯德基",
                                "link": _this.opt.link || (dty != 'ios' && site != 'douban' && androidDownUrl || "http://m.kfc.com.cn/APP/"),
                                "imagePath": (site != 'douban' && _this.opt.imagePath) || null
                            }, function (ret) {
                                $.am.debug.log("分享成功:" + JSON.stringify(ret));
                                //来自签到 就不要提示 到最终 签到成功提示
                                if (!_this.opt.signStore || typeof(_this.opt.signStore) == 'undefined') {
                                    amGloble.loading.hide();
                                    amGloble.msg("分享成功");
                                }
                                var opt = _this.opt;
                                if (opt.objType && opt.objId) {
                                    //增加计数
                                    user = amGloble.userInfo && amGloble.userInfo.token || '';
                                    amGloble.api.shares.exec(
                                        {'{type}': 'POST', 'token': user, 'objType': opt.objType, 'objId': opt.objId},
                                        function (res) {
                                            $.am.debug.log(JSON.stringify(res));
                                            if (res && res.errCode == 0 && res.data) {
                                                _this.cb && _this.cb({
                                                    errCode: 0,
                                                    data: res.data
                                                })
                                            } else {
                                                _this.cb && _this.cb({errCode: 1});
                                                amGloble.showErrMsg(res.errCode, {msg: "保存分享失败!", types: "share"});
                                            }
                                        });
                                } else {
                                    //直接成功，不计数
                                    _this.cb && _this.cb({
                                        errCode: 0
                                    });
                                }
                            }, function (ret) {
                                $.am.debug.log(JSON.stringify(ret));
                                if (ret && ret.result != -2) {
                                    if (ret.result == -3) {
                                        amGloble.msg("分享超时");
                                    } else {
                                        amGloble.msg("分享失败");
                                    }
                                }
                                failCll(1);
                            });
                        } else {
                            $.am.debug.log("未绑定");
                            //如果是如下 site 可能就是没有安装app
                            if (site == 'qq' || site == 'qzone' || site == 'wechat.session' || site == 'wechat.moment') {
                                amGloble.msg("请检查您是否已安装qq、微信等软件");
                                return false;
                            }
                            navigator.notification.confirm("需要绑定后才能分享,是否立即绑定?", function (button) {
                                $.am.debug.log(JSON.stringify(button));
                                if (button == 1) {
                                    setTimeout(function () {
                                        $.am.debug.log("smartmobile.social.bind :{ site: " + bindSite + " }");
                                        smartmobile.social.bind({"site": bindSite}, function (ret) {
                                            $.am.debug.log(JSON.stringify(ret));
                                            if (ret && ret.result == 0) {
                                                amGloble.userInfo[authKey] = ret.content.auth;//navi 返回的 验证信息
                                                sndBind[authKey] = ret.content.auth;
                                                amGloble.util.storage.set(snsKey, sndBind);
                                                amGloble.util.storage.set("BRANDKFC_/login", amGloble.userInfo);
                                                _this._share(site);
                                            } else {
                                                amGloble.msg("绑定失败!");
                                            }
                                        });
                                    }, 2000);
                                } else {
                                    $.am.debug.log("FAilCll");
                                    failCll(1);
                                }
                            }, "绑定账号", ["确定", "取消"]);
                        }
                    } else {
                        failCll(1);
                        amGloble.msg("分享失败");
                    }
                });

            } catch (e) {
                $.am.debug.log("error:" + e);
            }
        }
    }
    amGloble.util.share = new Share({
        id: "share_cover"
    });
})();





