cordova.define("com.hp.smartmobile.cordova.nativeui.widgets", function(require, exports, module) {

	var exec = require('cordova/exec');


	module.exports = {
		startBusy: function(opts) {
			exec(null, null, "NativeUIWidget", "startBusy", [opts]);
		},
		stopBusy: function(sc,fc) {
			exec(sc, fc, "NativeUIWidget", "stopBusy", []);
		},
		showInstantMessage: function(opts) {
			exec(null, null, "NativeUIWidget", "showInstantMessage", [opts]);
		},
		openSearchList: function(opts, sc, fc) {
			exec(sc, fc, "YumUIWidget", "openSearchList", [opts]);
		},
		showPopupMenu: function(opts, sc, fc) {
			exec(sc, fc, "NativeUIWidget", "showPopupMenu", [opts]);
		},
		showComboBox:function(opts, sc, fc){
			exec(sc, fc, "NativeUIWidget", "showComboBox", [opts]);
		},
		showTimePicker: function(opts, sc,fc) {
        	exec(sc, fc, "YumUIWidget", "showTimePicker", [opts]);
	    },
	    readBarcode: function(sc,fc) {
	        exec(sc, fc, "YumUIWidget", "readBarcode", []);
	    },
		startSplash: function() {
            exec(null, null, "YumUIWidget", "startSplash", []);
        },
        stopSplash: function() {
            exec(null, null, "YumUIWidget", "stopSplash", []);
        }
	};

});