cordova.define("com.yum.brandkfc.cordova.Media", function(require, exports, module) { 

var exec = require('cordova/exec');

module.exports = {
    resizeImage: function(options, successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'Media', 'resizeImage', [options]);
    },
    photoToAlbum: function(photoFile, successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'Media', 'photoToAlbum', [photoFile]);
    },
    base64PhotoToAlbum: function(photoFile, successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'Media', 'base64PhotoToAlbum', [photoFile]);
    },
	gallery: function(options, successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'Media', 'gallery', [options]);
    }
};

});

