cordova.define("com.yum.brandkfc.cordova.biz", function(require, exports, module) { 

var exec = require('cordova/exec');

module.exports = {
    login: function(successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'BizManager', 'login', []);
    },
	thirdPartyLogin: function(opts,successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'BizManager', 'thirdPartyLogin', [opts]);
    },
	openLocalHtml: function(opts) {
    	exec(null, null, 'BizManager', 'openLocalHtml', [opts]);
    }
    ,
	openSHRunning: function(opts) {
    	exec(null, null, 'BizManager', 'SHRunning', [opts]);
    }
    ,
	openNative: function(opts) {
    	exec(null, null, 'BizManager', 'openNative', [opts]);
    }
    ,
	openNearStores: function(opts) {
    	exec(null, null, 'BizManager', 'openNearStores', [opts]);
    }
    ,
	sendCoupon: function(opts,successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'BizManager', 'sendCoupon', [opts]);
    }
    ,
	getAddress: function(successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'BizManager', 'getAddress', []);
    }
    ,
	playVideo: function(opts) {
    	exec(null, null, 'BizManager', 'playVideo', [opts]);
    },
    openReactNative:function(opts,successCallback,errorCallback){
        exec(successCallback,errorCallback,'BizManager','openReactNative',[opts]);
    }
    ,
    openYRWebChat: function(opts) {
        exec(null, null, 'BizManager', 'openYRWebChat', [opts]);
    }
};

});

