cordova.define("com.yum.brandkfc.cordova.vpayService", function(require, exports, module) {

var exec = require('cordova/exec');

module.exports = {
    listCards: function(successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'CDVpayService', 'listCards', []);
    },
	bindCard: function(successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'CDVpayService', 'bindCard', []);
    },
    bindCardWithOptions: function(touchPage,successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'CDVpayService', 'bindCardWithOptions', [touchPage]);
    },
    listCardsData: function(successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'CDVpayService', 'listCardsData', []);
    },
	pay: function(opts,successCallback, errorCallback) {
    	exec(successCallback, errorCallback, 'CDVpayService', 'pay', [opts]);
    },
    isClientInstalled: function(successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'CDVpayService', 'isClientInstalled', []);
    },
    payBySDK: function(tn,mode,successCallback, errorCallback) {
        exec(successCallback, errorCallback, 'CDVpayService', 'payBySDK', [tn,mode]);
    }
};

});

