﻿if (navigator) {
    if (!navigator.notification) {
        navigator.notification = {
            alert: function (content, title, btn) {
                alert(content);
            },
            confirm: function (content, cb) {
                if (confirm(content)) {
                    cb(1);
                } else {
                    cb(0);
                }
            }
        }
    }

    if (!navigator.camera) {
        navigator.camera = {}
    }
    navigator.camera.getPicture = function (success, failed, option) {
        setTimeout(function () {
            success("../res/home_activity.png");
        })
    }
}

var smartmobile = {
    fileTransfer: {
        download: function (option, cb, fb) {
            cb({
                result: 0,
                message: "y",
                content: {
                    sourceRoot: option.url,
                    relativePath: ""
                }
            })
        }
    },
    nativeUIWidget: {
        confirm: function (options, successCallback, failedCallback) {
            if (confirm(options.description)) {
                successCallback && successCallback();
            } else {
                failedCallback && failedCallback();
            }
        },
        datePicker: function (options, successCallback, failedCallback) {

        },
        citySelecter: function (options, successCallback, failedCallback) {

        },
        startBusy: function (option) {
            $(document.body).append('<div class="cordova_busy"><div class="cordova_busy_c"><div class="cordova_busy_text">' + (option.caption || "正在加载") + '</div></div></div>');
        },
        stopBusy: function () {
            $("div.cordova_busy").remove();
        },
        showMap: function (option) {
        },
        showInstantMessage: function (option) {
            $("div.cordova_instantMessage").remove();
            clearTimeout(this.instantmsgTimer);
            $(document.body).append('<div class="cordova_instantMessage"><div class="text">' + (option.content) + '</div></div>');
            this.instantmsgTimer = setTimeout(function () {
                $("div.cordova_instantMessage").remove();
            }, option.duration || 3 * 1000);
        },
        showMessageBox: function (option, successCallback, failedCallback) {

        },
        selectPicture: function (successCallback, failedCallback, option) {
            alert("selectPicture");
        },
        showPopupMenu: function (opt, scb, fcb) {
            console.log("showPopupMenu:", opt);
            var self = this;

            if (!this._$comboBox) {
                this._$comboBox = $(".comp-showComboBox");
            }

            var html = [];
            $(opt.items).each(function (i, item) {
                html.push("<li>" + item.caption + "</li>");
            });
            this._$comboBox.find("ul").html(html.join(""));
            this._$comboBox.show();
            this._$comboBox.find("li").unbind().bind("click", function () {
                var idx = self._$comboBox.find("li").index($(this));
                self._$comboBox.hide();
                //eval('globle.$mobilet.' + opt.items[idx].action);
                //return false;
                scb && scb({
                    "name": opt.items[idx].caption
                });
            });

            this._$comboBox.find("span").unbind().click(function () {
                fcb && fcb({
                    "result": -2,
                    "message": "Canceled by user"
                });
                self._$comboBox.hide();
            });
        },
        readBarCode: function (successCallback, failedCallback) {
            alert("readBarCode");
        },
        readRQcode: function (successCallback, failedCallback) {
            alert("readRQcode");
        },
        openUrl: function (option, successCallback, failedCallback) {
            alert("openUrl");
        },
        viewFile: function (option, successCallback, failedCallback) {
            alert("viewFile");
        },
        popupWebsite: function (option, successCallback, failedCallback) {
            alert("popupWebsite");
        },
        showComboBox: function (option, successCallback, failedCallback) {
            console.log("showComboBox:", option);
            var i = prompt("showComboBox", "输入返回的序号");
            successCallback({
                result: 0,
                content: i
            });
        },
        openSearchList: function (option, successCallback, failedCallback) {
            console.log("openSearchList:", JSON.stringify(option));
            console.log("openSearch-items:", JSON.stringify(option.items));
            for (var p in option.items) {
                if (option.items[p].id == '6522') {
                    console.log('index:' + p);
                }
            }
            //.indexOf('{"id":6522,"pinyin":"S","name":"上海市","egiftcard":false}')//206
            var i = prompt("openSearchList", "输入返回的序号");
            option.items[i].cityName = option.items[i].text;
            successCallback(option.items[i]);
        }
    },
    storage: {
        persistProperty: function (opt, scb, fcb) {
            if (typeof opt.value == "string")
                opt.value = JSON.parse(opt.value);
            var content = {"content": opt.value};
            localStorage.setItem(opt.key, JSON.stringify(content));
            scb && scb();
        },
        readProperty: function (opt, scb, fcb) {
            var ret = localStorage.getItem(opt.key);
            if (ret == null || ret == "undefined" || ret == "") {
                fcb && fcb();
            } else
                scb && scb(ret);
        },
        removeProperty: function (opt, scb) {
            localStorage.removeItem(opt.key);
            scb && scb();
        }
    },
    appmanager: {
        stopTopApp: function () {
            if (confirm("您确定要关闭本页吗？")) {
                window.close();
            } else {
            }
        }
    },

}
var yum = {
    sys: {
        getBrightness: function (cb) {
            cb && cb({content: {brightness: 0.5}})
        },
        setBrightness: function () {
        },
        postLog: function () {
        },
        syncTime: function () {
        },
        locale: function () {
        },
        getInfo: function (cb) {
            cb({
                result: 0,
                content: {
                    resourceVersion: "3",
                    apkVersion: "3",
                    sec: window.baseUrl && window.baseUrl.indexOf("tlogin") != -1 ? "jkJrRIacBwcpK68d" : "WYjEbpFholuphDuO",
                    deviceId: "123123123",
                    currentContainerVer: "3.00"
                }
            });
        },
        post: function (paras, scb, fcb) {
            var para = paras.params;
            var url = para.url;
            var data = para.data;
            var dataType = para.dataType;
            var contentType = para.contentType;
            var timeout = para.timeout;

            console.log(url);
            $.ajax({
                url: url, //接口url
                type: "POST",
                data: JSON.stringify(data),
                dataType: dataType,
                contentType: contentType,
                timeout: timeout,
                success: function (ret, a, b) {
                    console.log(ret, a, b)
                    var r = {
                        content: {
                            responseStatusCode: b.status,
                            responseHeaders: {
                                "Set-Cookie": "JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"
                            },
                            responseData: ret,
                            responseCookies: {}
                        }
                    };
                    scb && scb(r);
                },
                error: function (ret) {
                    var r = {
                        content: {
                            responseStatusCode: ret.status,
                            responseHeaders: {
                                "Set-Cookie": "JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"
                            },
                            responseData: ret,
                            responseCookies: {}
                        }
                    };
                    fcb && fcb(r);
                    //if (ret.status == 406)
                    //    amGloble.giftCardSSOBind(scb, fcb);
                    //else if (ret.status == 401) {
                    //    amGloble.giftCardUpdatePhone(scb, fcb);
                    //} else {
                    //    fcb && fcb();
                    //}
                }
            });
        },
        get: function (paras, scb, fcb) {
            var para = paras.params;
            var url = para.url;
            var dataType = para.dataType;
            var contentType = para.contentType;
            var timeout = para.timeout;

            console.log(url);
            $.ajax({
                url: url, //接口url
                type: "GET",
                dataType: dataType,
                contentType: contentType,
                timeout: timeout,
                success: function (ret) {
                    var r = {
                        content: {
                            responseStatusCode: ret.status,
                            responseHeaders: {
                                "Set-Cookie": "JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"
                            },
                            responseData: ret,
                            responseCookies: {}
                        }
                    };
                    scb && scb(r);
                },
                error: function (ret) {
                    var r = {
                        content: {
                            responseStatusCode: ret.status,
                            responseHeaders: {
                                "Set-Cookie": "JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"
                            },
                            responseData: ret,
                            responseCookies: {}
                        }
                    };
                    fcb && fcb(r);
                }
            });
            //$.ajax({
            //    url: url, //接口url
            //    type: "POST",
            //    data: JSON.stringify(data),
            //    dataType: dataType,
            //    contentType: contentType,
            //    timeout: timeout,
            //    success: function(ret) {
            //        var content={responseStatusCode:ret.status, responseHeaders:{"Set-Cookie":"JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"}, responseData:ret, responseCookies:{}};
            //        scb && scb(content);
            //    },
            //    error: function(ret) {
            //        var content={responseStatusCode:ret.status, responseHeaders:{"Set-Cookie":"JSESSIONID=936AFF23108F7E4C34E02BBC4CC4A8CD.jvm"}, responseData:ret, responseCookies:{}};
            //        fcb && fcb(content);
            //        //if (ret.status == 406)
            //        //    amGloble.giftCardSSOBind(scb, fcb);
            //        //else if (ret.status == 401) {
            //        //    amGloble.giftCardUpdatePhone(scb, fcb);
            //        //} else {
            //        //    fcb && fcb();
            //        //}
            //    }
            //});
        }

    },
    appInfo: {
        getAppInfo: function () {

        }
    },
    geocoder: {
        resolveAddr: function (opt, cb) {
            setTimeout(function () {
                cb({
                    result: 0,
                    content: {
                        Name: "假地址"
                    }
                });
            }, 1000);
        }
    },
    pay: {
        alipay: function (payData, scb, fcb) {
            setTimeout(function () {
                scb && scb({
                    content: {resultStatus: 9000},
                });
            }, 1000);
        },
    },
    biz: {
        login: function (scb, fcb) {
            scb && scb({"message": "login success", "content": "", "result": 0});
        }
    }

}

$(function () {
    setTimeout(function () {
        window.device = {
            platform: "Android"
        }
        var ev = document.createEvent('HTMLEvents');
        ev.initEvent('deviceready', false, false);
        document.dispatchEvent(ev);

        $("head").append('<link href="libs/cordova.css" rel="stylesheet" type="text/css">');
    }, 500);
});
