﻿(function (window, $) {
//generate authorization code
    function getAuthorizationCode(inputObject) {

        if (!(inputObject instanceof Object)) {
            return "input should be an Object";
        }
        //alert(inputArray.join("_"));

        var md5UserName = "200001";//'<%=request.getServletContext().getInitParameter("md5UserName")%>';
        var md5Password = "kfcAppPwd";//'<%=request.getServletContext().getInitParameter("md5Password")%>';
        inputObject.md5UserName = md5UserName;
        inputObject.md5Password = md5Password;

        var sortedParamStr = "";
        var sortedInput = getSortedJson(inputObject);
        console.log('sortedInput:' + JSON.stringify(sortedInput));
        $.each(sortedInput, function (name, value) {
            //sortedParamStr += "_"+value;
            sortedParamStr += "_" + (value instanceof Object ? getJsonStr(value) : value);
        });
        sortedParamStr = sortedParamStr.substring(1, sortedParamStr.length);

        //alert(sortedParamStr.substring(1, sortedParamStr.length));
        console.log('sortMd5:' + sortedParamStr);
        //alert(paramArray.join("_"));
        //alert(md5(inputArray.join("_")));
        var result = 'md5username=' + md5UserName + '&md5=' + $.md5(sortedParamStr);
        return result;
    }


    function removeEmptyItem(actual) {
        var newArray = new Array();
        //console.log('before:'+actual.join("_"));
        for (var i = 0; i < actual.length; i++) {
            if (actual[i] === '') {
            } else {
                newArray.push(actual[i]);
            }
        }
        //console.log('after:'+newArray.join("_"));
        return newArray;
    }

//get sorted json string for MD5 authorization code
    function getJsonStr(jsonPojo) {
        var sortedData = getSortedJson(jsonPojo);

        var result;
        if (jsonPojo instanceof Array) {
            result = arrayToString(sortedData);
        } else {
            result = objectToString(sortedData);
        }

        return result;
    }

    function objectToString(jsonObject) {

        if (!(jsonObject instanceof Object)) {
            return "";
        }

        var array = new Array();
        $.each(jsonObject, function (name, value) {
            if (value instanceof Array) {
                array.push(name + "=" + arrayToString(value));
            } else if (value instanceof Object) {
                array.push(name + "=" + objectToString(value));
            } else {
                array.push(name + "=" + value);
            }
        });

        return "{" + array.join("_") + "}";
    }

    function arrayToString(jsonArray) {

        if (!(jsonArray instanceof Array)) {
            return "";
        }

        var array = new Array();
        $.each(jsonArray, function (index, data) {
            if (data instanceof Array) {
                array.push(arrayToString(data));
            } else if (data instanceof Object) {
                array.push(objectToString(data));
            } else {
                array.push(data);
            }
        });

        return "[" + array.join(", ") + "]";
    }

    function getSortedJson(jsonPojo) {

        var nameArray = new Array();

        if (jsonPojo instanceof Array) {
            var tempArray = new Array();
            $.each(jsonPojo, function (name, value) {
                if (value instanceof Object) {
                    tempArray.push(getSortedJson(value));
                } else {
                    tempArray.push(value);
                }
            });
            return tempArray;
        } else {
            $.each(jsonPojo, function (name, value) {
                nameArray.push(name);
            });
        }

        var sortedArray = nameArray.sort();

        var result = new Object();
        $.each(sortedArray, function (index, value) {
            var temp = jsonPojo[value];
            if (temp instanceof Object) {
                temp = getSortedJson(jsonPojo[value]);
            }
            result[value] = temp;
        });

        return result;
    }

    $.am.getAuthorizationCode = getAuthorizationCode;
    $.am.getJsonStr = getJsonStr;

})(window, jQuery);