cordova.define("com.yum.brandkfc.cordova.partnerDomainService", function(require, exports, module) {

var exec = require('cordova/exec');


module.exports = {
    getLocationInfo: function(sc,fc) {
        exec(sc, fc, "PartnerDomainService", "getLocationInfo", []);
    },
    saveUrlPhotoToAlbum: function(opts,sc,fc) {
        exec(sc, fc, "PartnerDomainService", "saveUrlPhotoToAlbum", [opts]);
    },
    saveBase64PhotoToAlbum: function(opts,sc,fc) {
        exec(sc, fc, "PartnerDomainService", "saveBase64PhotoToAlbum", [opts]);
    },
    getScanResult: function(sc,fc) {
        exec(sc, fc, "PartnerDomainService", "getScanResult", []);
    },
    persistProperty: function(opts,sc,fc) {
        exec(sc, fc, "PartnerDomainService", "persistProperty", [opts]);
    },
    readProperty: function(sc,fc) {
        exec(sc, fc, "PartnerDomainService", "readProperty", []);
    },
    getDeviceID: function(sc,fc) {
        exec(sc, fc, "PartnerDomainService", "getDeviceID", []);
    },
    onEventWithLabelAndParams:function(eventId, eventLabel, eventData) {
        var eventDataJson = JSON.stringify(eventData);
        exec(null, null, "PartnerDomainService", "onEventWithLabelAndParams", [eventId, eventLabel, eventDataJson]);
    }
};

});