cordova.define("com.yum.brandkfc.cordova.wxService", function(require, exports, module) {

var exec = require('cordova/exec');

module.exports = {
    isInstalled: function(successCallback) {
    	exec(successCallback, null, 'CDWXService', 'isInstalled', []);
    },
	share: function(sceneType,title,messageExt,webpageUrl,thumbImage,ui,successCallback) {
    	exec(successCallback, null, 'CDWXService', 'share', [sceneType,title,messageExt,webpageUrl,thumbImage,ui]);
    },
    shareImage: function(sceneType,imageType,imageExt,ui,successCallback) {
        exec(successCallback, null, 'CDWXService', 'shareImage', [sceneType,imageType,imageExt,ui]);
    },
	launchMini: function(userName,programPath,miniType) {
    	exec(null, null, 'CDWXService', 'launchMini', [userName,programPath,miniType]);
    },
    shareMini: function(title,description,webpageUrl,thumbImage,userName,programPath,shareTicket,miniType,successCallback) {
        exec(successCallback, null, 'CDWXService', 'shareMini', [title,description,webpageUrl,thumbImage,userName,programPath,shareTicket,miniType]);
    },
    pay: function(successCallback) {
    	exec(successCallback, null, 'CDWXService', 'pay', []);
    }
};

});

